#ifndef __NODES_H__
#define __NODES_H__

/**
 * Make a half-hearted attempt to post the nodes file to the web
 * site, then exit.
 */
void nodesDoPost(const char *nodesFile);

/**
 * Fork a grandchild and have it call nodesDoPost().
 */
void nodesPost(const char *nodesFile);

/**
 * If we don't have a better source of node information, try to download
 * a nodes file from a web site.
 */
void nodesBlockingGet(const char *nodesFile);

/**
 * Read a potential list of supernodes from the nodes file.
 * Return the number of connections attempted.
 */
int nodesRead(const char *nodesFile, Connection *cs, size_t nconn,
	size_t maxactive, char *username, char *networkname,
	struct sockaddr_in *server_addr, time_t last_time);

/**
 * Write the current list of Connections in the ConnectionState
 * CONNECTED_SUPERNODE_CONNECTED to the nodes file.  Return
 * the last modification time to the file.
 */
time_t nodesWrite(const char *nodesFile, Connection *cs, size_t nconn);

#endif
