/* Copyright (C) 2001  J.A. Bezemer  -  GPL >=2  -  NO WARRANTY WHATSOEVER */

#include <stdio.h>
#include <string.h>


/* Shell:

grep -a -b 'ConnectionInfo' kzalog10 | tail -1 | cut -d ':' -f 1
 => offset

tail --bytes=+544792 kzalog10 | ./kzaipextract | sort
 | grep -v -e '^[01]\.' -e '^10\.' -e '^192\.168\.' | uniq

*/

#define BUFSIZE 100000

int
main (void)
{
  unsigned char buffer[BUFSIZE];
  signed long buffilled = 0;
  signed long shiftamount;
  signed long bufpos = 10;
  /* At first time, skip a little bit because the IP is always lower than
     bufpos. */

  unsigned char *cp0, *cp1;

  while (!feof (stdin))
    {
      buffilled +=
	fread (buffer + buffilled, 1, BUFSIZE - buffilled - 10, stdin);

      cp0 = buffer + bufpos;
      cp1 = buffer + bufpos - 1;

      while (bufpos < buffilled)
	{
	  if (*cp1 == 0xbe && *cp0 == 0x04)
	    {
	      printf ("%d.%d.%d.%d\n", buffer[bufpos - 2], buffer[bufpos - 3],
		      buffer[bufpos - 4], buffer[bufpos - 5]);
	    }

	  bufpos++;
	  cp0++;
	  cp1++;
	}

      /* Now shift the buffer to make room for more data, but keep enough to
         find IPs that are just on or over the border */
      shiftamount = buffilled - 10;
      memmove (buffer, buffer + shiftamount, buffilled - shiftamount);
      buffilled -= shiftamount;
      bufpos -= shiftamount;
    }

  return 0;
}
